Chuyển đến nội dung
Diễn đàn CADViet
  • Thông báo

    • Nguyen Hoanh

      CADViet đã hoàn tất nâng cấp   14/09/2017

      Chào các bạn, CADViet đã hoàn tất việc nâng cấp lên phiên bản mới. Tất cả các chức năng đã hoạt động theo kỳ vọng của ban quản trị. Nếu có vấn đề gì cần phản hồi, các bản post ở đây nhé: Trân trọng, Nguyễn Hoành.
Đăng nhập để thực hiện theo  
halen

Xin sửa dùm cái lisp

Các bài được khuyến nghị

halen    0

Em mới học viết lisp lên viết 1 cái lisp đơn gian như thế này: tính diện tích bằng cách chọn đối tượng và xuất kết quả ra file text. Lisp có nội dung:

(defun c:are( / sel ent dientich)

(setq sel (entsel "\nHay chon doi tuong: "))

(setq ent (car sel))

(command ".area" "o" ent)

(setq dientich (getvar "area"))

(princ "Dien tich la: ")

(princ dientich)

(command "osmode" os)

(princ (* s dientich))

(setq diemdat (getpoint "\nDiem dat KQ"))

(command "text" diemdat "2.2" "0" (setq kq (rtos (dientich) 2 3)))

(princ)

)

Vấn đề của em ở đây là nó không xuất được kết quả ra text mong các bác giải thích dùm. Thank

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
gia_bach    1.442
Em mới học viết lisp lên viết 1 cái lisp đơn gian như thế này: tính diện tích bằng cách chọn đối tượng và xuất kết quả ra file text. Lisp có nội dung:

(defun c:are( / sel ent dientich)

(setq sel (entsel "\nHay chon doi tuong: "))

(setq ent (car sel))

(command ".area" "o" ent)

(setq dientich (getvar "area"))

(princ "Dien tich la: ")

(princ dientich)

(command "osmode" os)

(princ (* s dientich))

(setq diemdat (getpoint "\nDiem dat KQ"))

(command "text" diemdat "2.2" "0" (setq kq (rtos (dientich) 2 3)))

(princ)

)

Vấn đề của em ở đây là nó không xuất được kết quả ra text mong các bác giải thích dùm. Thank

- kiểu của (setq dientich (getvar "area")) là Real, nên truơc khi dùng lệnh Princ phải đổi sang kiểu String.

- biến s trong (princ (* s dientich)) chưa khai báo

Sorry post nhầm code. Update date='Jan 18 2010, 14:35'

Lisp của bạn đây :

(defun c:are( / sel ent dientich diemdat)
(setq sel (entsel "\nHay chon doi tuong: "))
(setq ent (car sel))
(command ".area" "o" ent)
(setq dientich (rtos (getvar "area") 2 3))
(princ "\nDien tich la: ")
(princ dientich)
;;;(command "osmode" os)
;;;(princ (* s dientich))
(setq diemdat (getpoint "\nDiem dat KQ"))
(command "text" diemdat "2.2" "0" dientich)
(princ)
)

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
halen    0
- kiểu của (setq dientich (getvar "area")) là Real, nên truơc khi dùng lệnh Princ phải đổi sang kiểu String.

- biến s trong (princ (* s dientich)) chưa khai báo

Lisp của bạn đây :

(defun c:are( / sel ent dientich kq diemdat)
(setq sel (entsel "\nHay chon doi tuong: "))
(setq ent (car sel))
(command ".area" "o" ent)
(type  (getvar "area"))
(princ "Dien tich la: ")
(princ (setq kq (rtos dientich 2 3)))
;;;(command "osmode" os)
;;;(princ (* s dientich))
(setq diemdat (getpoint "\nDiem dat KQ"))
(command "text" diemdat "2.2" "0" kq)
(princ)
)

Cảm ơn anh Gia bach rất nhiều. Có những người như anh thì những người mới bật bẽ viết như bọn em mới lớn được. Xin cảm ơn anh. Chúc anh năm mới mạnh khỏe và thành đạt.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
halen    0
- kiểu của (setq dientich (getvar "area")) là Real, nên truơc khi dùng lệnh Princ phải đổi sang kiểu String.

- biến s trong (princ (* s dientich)) chưa khai báo

Lisp của bạn đây :

(defun c:are( / sel ent dientich kq diemdat)
(setq sel (entsel "\nHay chon doi tuong: "))
(setq ent (car sel))
(command ".area" "o" ent)
;(type  (getvar "area"))
(princ "Dien tich la: ")
(princ (setq kq (rtos dientich 2 3)))
;;;(command "osmode" os)
;;;(princ (* s dientich))
(setq diemdat (getpoint "\nDiem dat KQ"))
(command "text" diemdat "2.2" "0" kq)
(princ)
)

Anh ơi em download về kiểm tra thử cái lisp anh sửa cho em nó báo nỗi như sau, nguyên văn nhé:

Command: ARE

Hay chon doi tuong: .area

Specify first corner point or [Object/Add/Subtract]: o

Select objects:

Area = 106.4594, Length = 42.9476

Command: Dien tich la: ; error: bad argument type: numberp: nil

Anh kiểm tra lại giúp em cái ah.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
gia_bach    1.442
Anh ơi em download về kiểm tra thử cái lisp anh sửa cho em nó báo nỗi như sau, nguyên văn nhé:

Command: ARE

Hay chon doi tuong: .area

Specify first corner point or [Object/Add/Subtract]: o

Select objects:

Area = 106.4594, Length = 42.9476

Command: Dien tich la: ; error: bad argument type: numberp: nil

Anh kiểm tra lại giúp em cái ah.

Sorry halen.

post nhầm code. Bạn lấy lại code ở bài trên.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay

Đăng nhập để thực hiện theo  

×